sc::PsiCCSD_T Class Reference

PsiCCSD_T is a concrete implementation of Psi CCSD(T) wave function. More...

`#include <psiwfn.h>`

Inheritance diagram for sc::PsiCCSD_T:
[legend]
Collaboration diagram for sc::PsiCCSD_T:
[legend]

## Public Member Functions

| PsiCCSD_T (const Ref< KeyVal > &)
| PsiCCSD_T (StateIn &)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
int | spin_polarized ()
| Return 1 if the alpha density is not equal to the beta density.
int | gradient_implemented () const
Public Member Functions inherited from sc::PsiWavefunction
| PsiWavefunction (const Ref< KeyVal > &)
| The KeyVal constructor. More...
| PsiWavefunction (StateIn &)
virtual void | write_basic_input (int conv)
| Writes out Psi input file entries specific to this PsiWavefunction. More...
void | compute ()
| Recompute at least the results that have compute true and are not already computed. More...
void | print (std::ostream &o=ExEnv::out0()) const
| Print information about the object.
RefSymmSCMatrix | density ()
| Returns the SO density.
int | nelectron ()
| Returns the number of electrons.
Ref< PsiExEnv > | get_psi_exenv () const
| Return an associated PsiExEnv object.
Ref< PsiInput > | get_psi_input () const
| Return an associated PsiInput object.
Public Member Functions inherited from sc::Wavefunction
| Wavefunction (StateIn &)
| Wavefunction (const Ref< KeyVal > &)
| The KeyVal constructor. More...
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
double | density (const SCVector3 &)
double | density_gradient (const SCVector3 &, double *)
double | natural_orbital (const SCVector3 &r, int iorb)
double | natural_orbital_density (const SCVector3 &r, int orb, double *orbval=0)
double | orbital (const SCVector3 &r, int iorb, const RefSCMatrix &orbs)
double | orbital_density (const SCVector3 &r, int iorb, const RefSCMatrix &orbs, double *orbval=0)
double | charge ()
| Returns the charge.
virtual RefSymmSCMatrix | ao_density ()
| Returns the AO density.
virtual RefSCMatrix | natural_orbitals ()
| Returns the natural orbitals.
virtual RefDiagSCMatrix | natural_density ()
| Returns the natural density (a diagonal matrix).
virtual RefSymmSCMatrix | alpha_density ()
| Return alpha electron densities in the SO basis.
virtual RefSymmSCMatrix | beta_density ()
| Return beta electron densities in the SO basis.
virtual RefSymmSCMatrix | alpha_ao_density ()
| Return alpha electron densities in the AO basis.
virtual RefSymmSCMatrix | beta_ao_density ()
| Return beta electron densities in the AO basis.
virtual RefSCMatrix | nao (double *atom_charges=0)
| returns the ao to nao transformation matrix
virtual RefSymmSCMatrix | overlap ()
| Returns the SO overlap matrix.
virtual RefSymmSCMatrix | core_hamiltonian ()
| Returns the SO core Hamiltonian.
virtual double | nuclear_repulsion_energy ()
| Returns the nuclear repulsion energy. More...
void | nuclear_repulsion_energy_gradient (double *g)
| Computes the nuclear repulsion gradient. More...
virtual void | nuclear_repulsion_energy_gradient (double **g)
| Computes the nuclear repulsion gradient. More...
RefSCDimension | ao_dimension ()
| Atomic orbital dimension.
RefSCDimension | so_dimension ()
| Symmetry adapted orbital dimension.
RefSCDimension | oso_dimension ()
| Orthogonalized symmetry adapted orbital dimension.
Ref< SCMatrixKit > | basis_matrixkit ()
| Matrix kit for AO, SO, orthogonalized SO, and MO dimensioned matrices.
Ref< Molecule > | molecule () const
| Returns the Molecule.
Ref< GaussianBasisSet > | basis () const
| Returns the basis set.
Ref< GaussianBasisSet > | atom_basis () const
| Returns the basis set describing the nuclear charge distributions.
const double * | atom_basis_coef () const
| Returns the coefficients of the nuclear charge distribution basis functions. More...
Ref< Integral > | integral ()
| Returns the integral evaluator.
void | symmetry_changed ()
| Call this if you have changed the molecular symmetry of the molecule contained by this MolecularEnergy. More...
RefSCMatrix | so_to_orthog_so ()
| Returns a matrix which does the default transform from SO's to orthogonal SO's. More...
RefSCMatrix | so_to_orthog_so_inverse ()
| Returns the inverse of the transformation returned by so_to_orthog_so.
OverlapOrthog::OrthogMethod | orthog_method () const
| Returns the orthogonalization method.
void | set_orthog_method (const OverlapOrthog::OrthogMethod &)
| (Re)Sets the orthogonalization method and makes this obsolete
double | lindep_tol () const
| Returns the tolerance for linear dependencies.
void | set_lindep_tol (double)
| Re(Sets) the tolerance for linear dependencies.
void | obsolete ()
| Marks all results as being out of date. More...
void | print (std::ostream &=ExEnv::out0()) const
| Print information about the object.
Public Member Functions inherited from sc::MolecularEnergy
| MolecularEnergy (const MolecularEnergy &)
| MolecularEnergy (const Ref< KeyVal > &)
| The KeyVal constructor. More...
| MolecularEnergy (StateIn &)
void | set_checkpoint ()
| Set up checkpointing.
void | set_checkpoint_file (const char *)
void | set_checkpoint_freq (int freq)
bool | if_to_checkpoint () const
| Check if need to checkpoint.
const char * | checkpoint_file () const
int | checkpoint_freq () const
MolecularEnergy & | operator= (const MolecularEnergy &)
virtual double | energy ()
| A wrapper around value();.
virtual RefSCDimension | moldim () const
void | guess_hessian (RefSymmSCMatrix &)
| Compute a quick, approximate hessian.
RefSymmSCMatrix | inverse_hessian (RefSymmSCMatrix &)
RefSymmSCMatrix | hessian ()
| If a molecule hessian object is given, it will be used to provide a hessian. More...
int | hessian_implemented () const
void | set_x (const RefSCVector &)
| Set and retrieve the coordinate values.
RefSCVector | get_cartesian_x ()
| Return the cartesian coordinates.
RefSCVector | get_cartesian_gradient ()
| Return the cartesian gradient.
RefSymmSCMatrix | get_cartesian_hessian ()
| Return the cartesian hessian.
Ref< MolecularCoor > | molecularcoor ()
Ref< NonlinearTransform > | change_coordinates ()
| An optimizer can call change coordinates periodically to give the function an opportunity to change its coordinate system. More...
void | print_natom_3 (const RefSCVector &, const char *t=0, std::ostream &o=ExEnv::out0()) const
| Nicely print n x 3 data that are stored in a vector.
void | print_natom_3 (double **, const char *t=0, std::ostream &o=ExEnv::out0()) const
void | print_natom_3 (double *, const char *t=0, std::ostream &o=ExEnv::out0()) const
Public Member Functions inherited from sc::Function
| Function (StateIn &)
| Function (const Function &)
| Function (const Ref< KeyVal > &, double funcacc=DBL_EPSILON, double gradacc=DBL_EPSILON, double hessacc=DBL_EPSILON)
| The keyval constructor reads the following keywords: More...
Function & | operator= (const Function &)
Ref< SCMatrixKit > | matrixkit () const
| Return the SCMatrixKit used to construct vectors and matrices. More...
RefSCDimension | dimension () const
| Return the SCDimension of the problem.
virtual double | value ()
| Return the value of the function.
int | value_needed () const
| Returns nonzero if the current value is not up-to-date.
int | do_value (int)
| If passed a nonzero number, compute the value the next time compute() is called. More...
AccResultdouble & | value_result ()
virtual void | set_desired_value_accuracy (double)
| Set the accuracy to which the value is to be computed.
virtual double | actual_value_accuracy () const
| Return the accuracy with which the value has been computed.
virtual double | desired_value_accuracy () const
| Return the accuracy with which the value is to be computed.
virtual int | value_implemented () const
| Information about the availability of values, gradients, and hessians. More...
RefSCVector | get_x () const
const RefSCVector & | get_x_no_copy () const
virtual RefSCVector | gradient ()
int | gradient_needed () const
int | do_gradient (int)
virtual void | set_desired_gradient_accuracy (double)
virtual double | actual_gradient_accuracy () const
virtual double | desired_gradient_accuracy () const
AccResultRefSCVector & | gradient_result ()
int | hessian_needed () const
int | do_hessian (int)
virtual void | set_desired_hessian_accuracy (double)
virtual double | actual_hessian_accuracy () const
virtual double | desired_hessian_accuracy () const
AccResultRefSymmSCMatrix & | hessian_result ()
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Protected Member Functions

void | write_input (int conv)
| Prepares a complete Psi input file. The input file is assumed to have been opened.

## Additional Inherited Members

Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Attributes inherited from sc::PsiWavefunction
int | nirrep_
int * | docc_
int * | socc_
int * | frozen_docc_
int * | frozen_uocc_
int | multp_
int | charge_
char * | memory_

## Detailed Description

PsiCCSD_T is a concrete implementation of Psi CCSD(T) wave function.

## Member Function Documentation

void sc::PsiCCSD_T::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::PsiWavefunction.

The documentation for this class was generated from the following file:

- psiwfn.h